# --------------------------------------------------------------------------- 
#  Hyper Operating System V4  ץץ                              
#    ᥤե SH2 gcc                                                 
#                                                                             
#                                   Copyright (C) 1998-2002 by Project HOS    
#                                   http://sourceforge.jp/projects/hos/       
# --------------------------------------------------------------------------- 

ROM = Yes


CC     = sh-elf-gcc
ASM    = sh-elf-gcc
LINK   = sh-elf-gcc
OBJCNV = sh-elf-objcopy


TARGET = sample

ifeq ($(ROM),Yes)
TARGET := $(TARGET)Rom
endif

CFLAGS = -c -m2 -I../../include
AFLAGS = -c -m2
LFLAGS = -m2 -nostartfiles -Wl,-v,-t,-Map,$(TARGET).map,-T$(TARGET).x

INCS   = kernel_id.h sample.h regs_sh7144.h sci1.h
OBJS   = crt0.o main.o ostimer.o vector.o sample.o sci1.o kernel_cfg.o
LIBS   = ../../lib/sh/sh2gcc/libh4sh2.a

${TARGET}.mot: ${OBJS} ${TARGET}.x
	${LINK} ${LFLAGS} -o ${TARGET}.out ${OBJS} ${LIBS}
	${OBJCNV} -O srec ${TARGET}.out ${TARGET}.mot

vector.o: vector.s
	${ASM} ${AFLAGS} vector.s -o vector.o

crt0.o: crt0.s
	${ASM} ${AFLAGS} crt0.s -o crt0.o

sample.o: sample.c ${INCS}
	${CC} ${CFLAGS} sample.c -o sample.o

sci1.o: sci1.c ${INCS}
	${CC} ${CFLAGS} sci1.c -o sci1.o

kernel_cfg.o: kernel_cfg.c ${INCS}
	${CC} ${CFLAGS} kernel_cfg.c -o kernel_cfg.o

kernel_cfg.c kernel_id.h: system.cfg
	cp system.cfg system_tmp.c
	${CC} -E system_tmp.c -o system.i
	hos4cfg system.i
	rm system.i
	rm system_tmp.c


clean:
	rm -f *.mot
	rm -f *.map
	rm -f *.out
	rm -f *.o
	rm -f kernel_id.h
	rm -f kernel_cfg.c



# --------------------------------------------------------------------------- 
#  Copyright (C) 1998-2002 by Project HOS                                     
# --------------------------------------------------------------------------- 
