/** 
 *  Sample program for Hyper Operating System V4 Advance
 *
 * @file  sample.c
 * @brief ץץ
 *
 * @version $Id: sample.c,v 1.1.1.1 2006/08/16 16:27:04 ryuz Exp $
 *
 * Copyright (C) 1998-2006 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#include "kernel.h"
#include "kernel_id.h"
#include "sample.h"
#include "sci1.h"

#define LEFT(num)	((num) <= 1 ? 5 : (num) - 1)
#define RIGHT(num)	((num) >= 5 ? 1 : (num) + 1)

/*const VP _kernel_int_isp = (VP)0xfffffff0;*/


/* void sim_puts(void *addr); */



/* ϥɥ */
void Sample_Initialize(VP_INT exinf)
{
	/* ư */
	act_tsk(TSKID_PRINT);
	act_tsk(TSKID_SAMPLE1);
	act_tsk(TSKID_SAMPLE2);
	act_tsk(TSKID_SAMPLE3);
	act_tsk(TSKID_SAMPLE4);
	act_tsk(TSKID_SAMPLE5);
}


/* ŬʻԤ */
void rand_wait(void)
{
	dly_tsk(rand() % 1000 + 100);	
}


/* ɽ */
void print_state(int num, char *text)
{
	T_PRINT_MSG *msg;
	VP  mem;
	
	/*  */
	get_mpf(MPFID, &mem);
	msg = (T_PRINT_MSG *)mem;

	/* ʸ */
	msg->text[0] = '0' + num;
	msg->text[1] = ' ';
	msg->text[2] = ':';
	msg->text[3] = ' ';
	strcpy(&msg->text[4], text);
	strcat(msg->text, "\n");
	
	/* ɽ */
	snd_mbx(MBXID, (T_MSG *)msg);
}


/* ץ륿 */
void Sample_Task(VP_INT exinf)
{
	char buf[16];
	int  num;

	num = (int)exinf;
	
	print_state(num, "start");

	/* ůؼԤο */
	for ( ; ; )
	{
		/* Ŭʻֹͤ */
		print_state(num, "thinking");
		rand_wait();

		/* Υեޤǥ롼 */
		for ( ; ; )
		{
			/* ˼ */
			wai_sem(LEFT(num));
			if ( pol_sem(RIGHT(num)) == E_OK )
			{
				break;	/* ξ줿 */
			}
			sig_sem(LEFT(num));	/* ʤΥ */
			
			/* ŬʻԤ */
			print_state(num, "hungry");
			rand_wait();

			/* ˼ */
			wai_sem(RIGHT(num));
			if ( pol_sem(LEFT(num)) == E_OK )
			{
				break;	/* ξ줿 */
			}
			sig_sem(RIGHT(num));	/* ʤΥ */

			/* ŬʻԤ */
			print_state(num, "hungry");
			rand_wait();
		}
		
		/* Ŭʻ֡٤ */
		print_state(num, "eating");
		rand_wait();
		
		/* ե֤ */
		sig_sem(LEFT(num));
		sig_sem(RIGHT(num));
	}
}

/* ɽ */
void Sample_Print(VP_INT exinf)
{
	T_PRINT_MSG *msg;
	
	Sci1_Initialize();
	
	for ( ; ; )
	{
		rcv_mbx(MBXID, (T_MSG **)&msg);
/*		sim_puts(msg->text);	*/
		Sci1_PutString(msg->text);
		rel_mpf(MPFID, msg);
	}
}






/* end of file */
