OUTPUT_FORMAT("coff-sh")
OUTPUT_ARCH(sh)
MEMORY
{
  /* ¡ROM 0x000000000x0003ffff */
  /* ¡I/O 0xffff80000xffff87ff */
  /* ¡RAM 0xfffff0000xffffffff */
  vector : o = 0x00000000, l = 0x00000400
  rom    : o = 0x00000400, l = 0x0003fc00
  ram    : o = 0xffffe000, l = 0x00002000
  stack  : o = 0xfffffff0, l = 0x00000010
}
SECTIONS
{
  .vector :
  {
    _VECTOR_START = . ;
    *(.vector)
  } > vector
  .dtcvect : {
     ___dtcvect_top = . ;
     *(.dtcvect)
     ___dtcvect_end = . ;
  } > rom  
  .text :
  {
    _TEXT_START = . ;
    *(.vector)
    *(.text)
    *(.strings)
    *(.rodata)
    *(.rodata.str1.4)
    _TEXT_END = . ;
  } > rom
  .rodata : {
     *(.rodata)
     *(.rodata.*)
     _erodata = .;
  } > rom
  .data : AT (_erodata)
  {
    _DATA_ROM = _erodata;
    _DATA_START = . ;
    *(.data)
    *(.gcc_exc*)
    ___EH_FRAME_BEGIN__ = . ;
    *(.eh_fram*)
    ___EH_FRAME_END__ = . ;
    LONG(0);
    _DATA_END = . ;
    _edata = . ;
  } > ram
  .bss :
  {
    _BSS_START = . ;
    *(.bss)
    *(COMMON)
    _BSS_END = . ;
  } > ram
  .stack :
  {
    _STACK_START = . ;
    *(.stack);
    _STACK_END = . ;
  } > stack
}
